package jtriton;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

public class LDP {

	String			file = null;
	FileInputStream in = null;

	int i1 = 0;
	String str = null;
	
	private int readInt() throws Exception {
		byte[] c = new byte[4];
		int data = 0;
		in.read(c, 0, 4);
		for (int i = 0; i < 4; i++) {
			data |= ((int) c[i] & 0x000000ff) << (8 * i);
		}
		return data;
	}

	private String readString(int length) throws Exception {
		byte[] cbuf = new byte[length];
		in.read(cbuf, 0, length);
		return new String(cbuf);
	}

	public boolean readline() throws Exception {
		if (in.available() == 0)
			return false;
		this.i1 = readInt();
		this.str = readString(readInt());
		return true;
	}
	
	private void initInput(String fname) {
		try {
			in = new FileInputStream(fname);
			file = fname;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public LDP(String fname) {
		initInput(fname);
	}

	public LDP(File input) {
		initInput(input.getAbsolutePath());
	}

	public LDP() {
		File f = FileSelect.file();
		if (f != null)
			initInput(f.getAbsolutePath());
	}
	
	public static void main(String[] args) {

		LDP data = null;
		if (args.length == 0)
			data = new LDP();
			//data = new LDP("/home/mirsev/Desktop/UnisonShared/GPS-Triton/Tracks/000/LDPOutput_RC-SD_002.bin");
			//data = new LDP("/home/mirsev/Desktop/UnisonShared/GPS-Triton/Tracks/002-Finland/LDPOutput_RC-SD_000.bin");
		else 
			data = new LDP(args[0]);
		if (data.in == null)
			return;
		
		try {
			String out = data.file;
			int dot = out.lastIndexOf('.');
			if (dot > 0)
				out = out.substring(0, dot);
			out = out + ".kml";
			System.out.println("Output file: " + out);
			NMEAdata nmea = new NMEAdata();
			KMLWriter kml = new KMLWriter(out, data.file);
			kml.pathStart("path object");
			while(data.readline())
				if (nmea.parse(data.str))
					kml.pathPoint(nmea.latitude, nmea.longitude, nmea.altitude);
			kml.pathEnd();
			kml.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
